-- IGAS
-- In-Game Addon System
-- Author: kurapica.igas@gmail.com
-- Create Date : 2011/03/01
-- ChangeLog   :

local version = 3

if not IGAS:NewAddon("IGAS", version) then
	return
end

----------------------------------------------
-- Addon Initialize
----------------------------------------------
-- Keep this setting for gui lib, no need to set _AutoWrapper in other addons.
_AutoWrapper = false

----------------------------------------------
-- Looger
----------------------------------------------
Log = IGAS:NewLogger("IGAS")

Log.TimeFormat = "%X"
Log:SetPrefix(1, "[IGAS][Trace]")
Log:SetPrefix(2, "[IGAS][Debug]")
Log:SetPrefix(3, "[IGAS][Info]")
Log:SetPrefix(4, "[IGAS][Warn]")
Log:SetPrefix(5, "[IGAS][Error]")
Log:SetPrefix(6, "[IGAS][Fatal]")
Log.LogLevel = 3

Log:AddHandler(print)

----------------------------------------------
-- Localization
----------------------------------------------
L = IGAS:NewLocale("IGAS")

----------------------------------------------
-- Event Handler
----------------------------------------------
function OnLoad(self)
	-- SavedVariables
	self:AddSavedVariable("IGAS_DB")
	self:AddSavedVariable("IGAS_DB_Char")
	
	-- Log Level
	if type(IGAS_DB.LogLevel) == "number" then
		Log.LogLevel = IGAS_DB.LogLevel
	end

	-- Slash command
	self:AddSlashCmd("/igas")
end

function OnSlashCmd(self, option, info)
	if option and option:lower() == "log" and tonumber(info) then
		Log.LogLevel = tonumber(info)
		IGAS_DB.LogLevel = Log.LogLevel
		
		Log(3, "%s's LogLevel is switched to %d.", _Name, Log.LogLevel)
	end
end