-- Author      : Kurapica
-- Create Date : 2012/08/27
-- Change Log  :

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.IFAutoPosition", version) then
	return
end

----------------------------------------------------------
-- Manage Functions
----------------------------------------------------------
do
	InCombatLockdown = InCombatLockdown
	pairs = pairs
	wipe = wipe
	pcall = pcall

	geterrorhandler = geterrorhandler or function()
		return print
	end

	errorhandler = errorhandler or function(err)
		return pcall(geterrorhandler(), err)
	end

	_Global = "Global"

	_Loaded = false
	_LoadingList = setmetatable({}, {__mode="k"})

	_M:ActiveThread("OnLoad")

	function Init(frm)
		local set = frm.ForCharacter and _DBChar[frm:GetName()] or _DB[frm:GetName()]

		if set then
			if set.Size then
				frm.Size = set.Size
			end
			if set.Location then
				frm.Location = set.Location
			end
		end
	end

	function OnLoad(self)
		-- DB
		IGAS_DB_Char.IFAutoPosition_DB = IGAS_DB_Char.IFAutoPosition_DB or {}
		_DBChar = IGAS_DB_Char.IFAutoPosition_DB

		IGAS_DB.IFAutoPosition_DB = IGAS_DB.IFAutoPosition_DB or {}
		_DB = IGAS_DB.IFAutoPosition_DB

		if InCombatLockdown() then
			System.Threading.WaitEvent "PLAYER_REGEN_ENABLED"
		end

		local ok, ret

		for frm in pairs(_LoadingList) do
			ok, ret = pcall(Init, frm)

			if not ok then
				errorhandler(ret)
			end
		end

		wipe(_LoadingList)
		_LoadingList = nil

		_Loaded = true
	end
end

-----------------------------------------------
--- IFAutoPosition
-- @type interface
-- @name IFAutoPosition
-----------------------------------------------
interface "IFAutoPosition"
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	--[[ Define Dispose method if you want know object is disposed.
	function Dispose(self)
	end --]]

	------------------------------------------------------
	-- Property
	------------------------------------------------------
	-- ForCharacter
	property "ForCharacter" {
		Get = function(self)
			return true
		end,
	}

	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	local function OnPositionChanged(self)
		if not _Loaded then return end

		if self.ForCharacter then
			_DBChar[self:GetName()] = _DBChar[self:GetName()] or {}
			_DBChar[self:GetName()].Location = self.Location
		else
			_DB[self:GetName()] = _DB[self:GetName()] or {}
			_DB[self:GetName()].Location = self.Location
		end
	end

	local function OnSizeChanged(self)
		if not _Loaded then return end

		if self.ForCharacter then
			_DBChar[self:GetName()] = _DBChar[self:GetName()] or {}
			_DBChar[self:GetName()].Size = self.Size
		else
			_DB[self:GetName()] = _DB[self:GetName()] or {}
			_DB[self:GetName()].Size = self.Size
		end
	end

	------------------------------------------------------
	-- Initialize
	------------------------------------------------------
    function IFAutoPosition(self)
		if Reflector.ObjectIsClass(self, Region) then
			if _Loaded then
				local set = self.ForCharacter and _DBChar[self:GetName()] or _DB[self:GetName()]

				if set then
					if set.Size then
						self.Size = set.Size
					end
					if set.Location then
						self.Location = set.Location
					end
				end
			else
				_LoadingList[self] = true
			end

			if self:HasScript("OnPositionChanged") then
				self.OnPositionChanged = self.OnPositionChanged + OnPositionChanged
			end
			if self:HasScript("OnSizeChanged") then
				self.OnSizeChanged = self.OnSizeChanged + OnSizeChanged
			end
		end
    end
endinterface "IFAutoPosition"