-- Author      : Kurapica
-- Create Date : 2012/08/06
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- AlternatePowerBar
-- <br><br>inherit <a href="..\Base\StatusBar.html">StatusBar</a> For all methods, properties and scriptTypes
-- @name AlternatePowerBar
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.AlternatePowerBar", version) then
	return
end

class "AlternatePowerBar"
	inherit "StatusBar"
	extend "IFAlternatePower"

	PowerBarColor = PowerBarColor
	
	ADDITIONAL_POWER_BAR_NAME = "MANA"
	ADDITIONAL_POWER_BAR_INDEX = 0
	
	local UnitPower = UnitPower
	local UnitPowerMax = UnitPowerMax
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Refresh(self)
		self.Value = UnitPower('player', ADDITIONAL_POWER_BAR_INDEX) * 100 / UnitPowerMax('player', ADDITIONAL_POWER_BAR_INDEX)
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------

	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function AlternatePowerBar(name, parent)
		local bar = Super(name, parent)

		bar.StatusBarTexturePath = [[Interface\TargetingFrame\UI-StatusBar]]
		bar.MinMaxValue = MinMax(1, 100)
		
		local info = PowerBarColor[ADDITIONAL_POWER_BAR_NAME]
		bar.StatusBarColor = ColorType(info.r, info.g, info.b)
		
		return bar
	end
endclass "AlternatePowerBar"