﻿-- Author      : Kurapica
-- Create Date : 2012/06/25
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- MasterLooterIcon
-- <br><br>inherit <a href="..\Base\Texture.html">Texture</a> For all methods, properties and scriptTypes
-- @name MasterLooterIcon
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.MasterLooterIcon", version) then
	return
end

class "MasterLooterIcon"
	inherit "Texture"
	extend "IFParty" "IFPartyLoot"

	local GetLootMethod = GetLootMethod
	local UnitIsUnit = UnitIsUnit
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Refresh(self)
		local method, pid, rid = GetLootMethod()
		
		local unit = method == "master" and ((pid and (pid == 0 and "player" or "party"..pid)) or (rid and "raid"..rid))
		
		self.Visible = unit and UnitIsUnit(unit, self.Unit)
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------

	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function MasterLooterIcon(name, parent)
		local icon = Super(name, parent)

		icon.TexturePath = [[Interface\GroupFrame\UI-Group-MasterLooter]]

		return icon
	end
endclass "MasterLooterIcon"