-- Author      : Kurapica
-- Create Date : 2012/06/25
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- RaidTargetIcon
-- <br><br>inherit <a href="..\Base\Texture.html">Texture</a> For all methods, properties and scriptTypes
-- @name RaidTargetIcon
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.RaidTargetIcon", version) then
	return
end

class "RaidTargetIcon"
	inherit "Texture"
	extend "IFRaidTarget"

	local GetRaidTargetIndex = GetRaidTargetIndex
	local SetRaidTargetIconTexture = SetRaidTargetIconTexture

	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Refresh(self)
		local index = GetRaidTargetIndex(self.Unit)
		
		if index then
			SetRaidTargetIconTexture(self, index)
			self.Visible = true
		else
			self.Visible = false
		end
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------

	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function RaidTargetIcon(name, parent)
		local icon = Super(name, parent)
		
		icon.TexturePath = [[Interface\TargetingFrame\UI-RaidTargetingIcons]]
		
		return icon
	end
endclass "RaidTargetIcon"