﻿-- Author      : Kurapica
-- Create Date : 2012/06/25
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- RoleIcon
-- <br><br>inherit <a href="..\Base\Texture.html">Texture</a> For all methods, properties and scriptTypes
-- @name RoleIcon
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.RoleIcon", version) then
	return
end

class "RoleIcon"
	inherit "Texture"
	extend "IFParty" "IFPlayerRole"
	
	local UnitGroupRolesAssigned = UnitGroupRolesAssigned
	local GetTexCoordsForRoleSmallCircle = GetTexCoordsForRoleSmallCircle
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Refresh(self)
		local role = UnitGroupRolesAssigned(self.Unit)
		
		if role == 'TANK' or role == 'HEALER' or role == 'DAMAGER' then
			self:SetTexCoord(GetTexCoordsForRoleSmallCircle(role))
			self.Visible = true
		else
			self.Visible = false
		end
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------

	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function RoleIcon(name, parent)
		local icon = Super(name, parent)

		icon.TexturePath = [[Interface\LFGFrame\UI-LFG-ICON-PORTRAITROLES]]
		
		return icon
	end
endclass "RoleIcon"