-- Author      : Kurapica
-- Create Date : 2012/08/06
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- IFAlternatePower
-- @type Interface
-- @name IFAlternatePower
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.IFAlternatePower", version) then
	return
end

pcall = pcall
errorhandler = errorhandler

ADDITIONAL_POWER_BAR_NAME = "MANA"
ADDITIONAL_POWER_BAR_INDEX = 0

_All = "all"
_IFAlternatePowerUnitList = _IFAlternatePowerUnitList or UnitList(_Name)

function _IFAlternatePowerUnitList:OnUnitListChanged()
	self:RegisterEvent("UNIT_DISPLAYPOWER")
	self:RegisterEvent("UNIT_MAXPOWER")
	self:RegisterEvent("UNIT_POWER")

	self.OnUnitListChanged = nil
end

function _IFAlternatePowerUnitList:ParseEvent(event, unit, powerType)
	if unit ~= "player" then return end

	if event == "UNIT_DISPLAYPOWER" then
		_NeedShow = UnitPowerType("player") ~= ADDITIONAL_POWER_BAR_INDEX

		self:EachK(_All, "Visible", _NeedShow)
	elseif _NeedShow and (not powerType or powerType == "MANA") then
		self:EachK(_All, "Refresh")
	end
end

interface "IFAlternatePower"
	extend "IFUnitElement"

	_IFAlternatePowerUnitList = _IFAlternatePowerUnitList

	------------------------------------------------------
	-- Enum
	------------------------------------------------------

	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Dispose(self)
		_IFAlternatePowerUnitList[self] = nil
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------

	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	local function OnUnitChanged(self)
		if self.Unit and self.Unit:lower() == "player" then
			_IFAlternatePowerUnitList[self] = _All
			self.Visible = true
		else
			_IFAlternatePowerUnitList[self] = nil
			self.Visible = false
		end
	end

	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function IFAlternatePower(self)
		if select(2, UnitClass("player")) == "DRUID" then
			self.OnUnitChanged = self.OnUnitChanged + OnUnitChanged
		else
			self.Visible = false
		end
	end
endinterface "IFAlternatePower"