-- Author      : Kurapica
-- Create Date : 2012/07/14
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- IFComboPoint
-- @type Interface
-- @name IFComboPoint
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.IFComboPoint", version) then
	return
end

pcall = pcall
errorhandler = errorhandler

_All = "all"
_IFComboPointUnitList = _IFComboPointUnitList or UnitList(_Name)

function _IFComboPointUnitList:OnUnitListChanged()
	self:RegisterEvent("UNIT_COMBO_POINTS")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	
	self.OnUnitListChanged = nil
end

function _IFComboPointUnitList:ParseEvent(event, unit)
	if unit and unit ~= "player" then return end
	
	self:EachK(_All, "Refresh")
end

interface "IFComboPoint"
	extend "IFUnitElement"
	
	_IFComboPointUnitList = _IFComboPointUnitList
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Dispose(self)
		_IFComboPointUnitList[self] = nil
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------
	
	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	
	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function IFComboPoint(self)
		_IFComboPointUnitList[self] = _All
	end
endinterface "IFComboPoint"