-- Author      : Kurapica
-- Create Date : 2012/08/06
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- IFHealPrediction
-- @type Interface
-- @name IFHealPrediction
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.IFHealPrediction", version) then
	return
end

_IFHealPredictionUnitList = _IFHealPredictionUnitList or UnitList(_Name)

function _IFHealPredictionUnitList:OnUnitListChanged()
	self:RegisterEvent("UNIT_HEAL_PREDICTION")
	
	self.OnUnitListChanged = nil
end

interface "IFHealPrediction"
	extend "IFUnitElement"
	
	_IFHealPredictionUnitList = _IFHealPredictionUnitList
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Dispose(self)
		_IFHealPredictionUnitList[self] = nil
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------
	
	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	local function OnUnitChanged(self)
		_IFHealPredictionUnitList[self] = self.Unit
	end
	
	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function IFHealPrediction(self)
		self.OnUnitChanged = self.OnUnitChanged + OnUnitChanged
	end
endinterface "IFHealPrediction"