-- Author      : Kurapica
-- Create Date : 2012/06/25
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- IFHealth
-- @type Interface
-- @name IFHealth
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.IFHealth", version) then
	return
end

_IFHealthUnitList = _IFHealthUnitList or UnitList(_Name)

function _IFHealthUnitList:OnUnitListChanged()
	self:RegisterEvent("UNIT_HEALTH")
	self:RegisterEvent("UNIT_HEALTH_FREQUENT")
	self:RegisterEvent("UNIT_MAXHEALTH")
	self:RegisterEvent("UNIT_CONNECTION")
	self:RegisterEvent("UNIT_FACTION")
	
	self.OnUnitListChanged = nil
end

function FrequentRefresh(self)
	if self.RequireFrequent then
		self:Refresh()
	end
end

function UnFrequentRefresh(self)
	if not self.RequireFrequent then
		self:Refresh()
	end
end

function _IFHealthUnitList:ParseEvent(event, unit, ...)
	local chk, ret
	
	if event == "UNIT_HEALTH_FREQUENT" then
		self:EachK(unit, FrequentRefresh)
	elseif event == "UNIT_HEALTH" then
		self:EachK(unit, UnFrequentRefresh)
	else
		self:EachK(unit, "Refresh")
	end
end

interface "IFHealth"
	extend "IFUnitElement"
	
	_IFHealthUnitList = _IFHealthUnitList
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Dispose(self)
		_IFHealthUnitList[self] = nil
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------
	property "RequireFrequent" {
		Get = function(self)
			return self.__IFHealth_RequireFrequent or false
		end,
		Set = function(self, flag)
			self.__IFHealth_RequireFrequent = flag
		end,
		Type = Boolean,
	}
	
	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	local function OnUnitChanged(self)
		_IFHealthUnitList[self] = self.Unit
	end
	
	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function IFHealth(self)
		self.OnUnitChanged = self.OnUnitChanged + OnUnitChanged
	end
endinterface "IFHealth"