-- Author      : Kurapica
-- Create Date : 2012/07/22
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- IFHolyPower
-- @type Interface
-- @name IFHolyPower
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.IFHolyPower", version) then
	return
end

pcall = pcall
errorhandler = errorhandler

_All = "all"
_IFHolyPowerUnitList = _IFHolyPowerUnitList or UnitList(_Name)

function _IFHolyPowerUnitList:OnUnitListChanged()
	self:RegisterEvent("UNIT_POWER")
	
	self.OnUnitListChanged = nil
end

function _IFHolyPowerUnitList:ParseEvent(event, unit, powerType)
	if unit ~= "player" or powerType ~= "HOLY_POWER" then return end
	
	self:EachK(_All, "Refresh")
end

interface "IFHolyPower"
	extend "IFUnitElement"
	
	local UnitClass = UnitClass
	_IFHolyPowerUnitList = _IFHolyPowerUnitList
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Dispose(self)
		_IFHolyPowerUnitList[self] = nil
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------	
	
	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	local function OnUnitChanged(self)
		if self.Unit and self.Unit:lower() == "player" then
			_IFHolyPowerUnitList[self] = _All
			self.Visible = true
		else
			_IFHolyPowerUnitList[self] = nil
			self.Visible = false
		end
	end
	
	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function IFHolyPower(self)
		if select(2, UnitClass("player")) == "PALADIN" then
			self.OnUnitChanged = self.OnUnitChanged + OnUnitChanged
		else
			self.Visible = false
		end
	end
endinterface "IFHolyPower"