-- Author      : Kurapica
-- Create Date : 2012/07/12
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- IFParty
-- @type Interface
-- @name IFParty
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.IFParty", version) then
	return
end

pcall = pcall
errorhandler = errorhandler

_All = "all"
_IFPartyUnitList = _IFPartyUnitList or UnitList(_Name)

function _IFPartyUnitList:OnUnitListChanged()
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	self:RegisterEvent("GROUP_ROSTER_UPDATE")
	
	self.OnUnitListChanged = nil
end

function _IFPartyUnitList:ParseEvent(event)
	self:EachK(_All, "Refresh")
end

interface "IFParty"
	extend "IFUnitElement"
	
	_IFPartyUnitList = _IFPartyUnitList
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Dispose(self)
		_IFPartyUnitList[self] = nil
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------
	
	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	
	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function IFParty(self)
		_IFPartyUnitList[self] = _All
	end
endinterface "IFParty"