-- Author      : Kurapica
-- Create Date : 2012/06/25
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- IFPortrait
-- @type Interface
-- @name IFPortrait
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 2
if not IGAS:NewAddon("IGAS.Widget.Unit.IFPortrait", version) then
	return
end

_IFPortraitUnitList = _IFPortraitUnitList or UnitList(_Name)

function _IFPortraitUnitList:OnUnitListChanged()
	self:RegisterEvent("UNIT_PORTRAIT_UPDATE")
	self:RegisterEvent("UNIT_MODEL_CHANGED")
	self:RegisterEvent("UNIT_CONNECTION")
	self:RegisterEvent("PARTY_MEMBER_ENABLE")
	
	self.OnUnitListChanged = nil
end

function _IFPortraitUnitList:ParseEvent(event, unit)	
	if type(unit) == "number" then
		unit = "party"..unit
	end
	
	self:EachK(unit, "Refresh")
end

interface "IFPortrait"
	extend "IFUnitElement"
	
	_IFPortraitUnitList = _IFPortraitUnitList
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Dispose(self)
		_IFPortraitUnitList[self] = nil
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------
	
	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	local function OnUnitChanged(self)
		_IFPortraitUnitList[self] = self.Unit
	end
	
	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function IFPortrait(self)
		self.OnUnitChanged = self.OnUnitChanged + OnUnitChanged
	end
endinterface "IFPortrait"