-- Author      : Kurapica
-- Create Date : 2012/06/25
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- IFPower
-- @type Interface
-- @name IFPower
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.IFPower", version) then
	return
end

_IFPowerUnitList = _IFPowerUnitList or UnitList(_Name)

function _IFPowerUnitList:OnUnitListChanged()
	self:RegisterEvent("UNIT_POWER")
	self:RegisterEvent("UNIT_POWER_BAR_SHOW")
	self:RegisterEvent("UNIT_POWER_BAR_HIDE")
	self:RegisterEvent("UNIT_DISPLAYPOWER")
	self:RegisterEvent("UNIT_CONNECTION")
	self:RegisterEvent("UNIT_MAXPOWER")
	self:RegisterEvent("UNIT_FACTION")
	
	self.OnUnitListChanged = nil
end

interface "IFPower"
	extend "IFUnitElement"
	
	_IFPowerUnitList = _IFPowerUnitList
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Dispose(self)
		_IFPowerUnitList[self] = nil
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------
	property "RequireFrequent" {
		Get = function(self)
			return self.__IFPower_RequireFrequent or false
		end,
		Set = function(self, flag)
			self.__IFPower_RequireFrequent = flag
		end,
		Type = Boolean,
	}
	
	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	local function OnUpdate(self)
		self:Refresh()
	end
	
	local function OnUnitChanged(self)
		_IFPowerUnitList[self] = self.Unit
		
		if self.RequireFrequent and self:HasScript("OnUpdate") then
			if self.Unit == "player" or self.Unit == "pet" then
				self.OnUpdate = self.OnUpdate + OnUpdate
			else
				self.OnUpdate = self.OnUpdate - OnUpdate
			end
		end
	end
	
	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function IFPower(self)
		self.OnUnitChanged = self.OnUnitChanged + OnUnitChanged
	end
endinterface "IFPower"