-- Author      : Kurapica
-- Create Date : 2012/07/14
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- IFReadyCheck
-- @type Interface
-- @name IFReadyCheck
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.IFReadyCheck", version) then
	return
end

pcall = pcall
errorhandler = errorhandler
GetReadyCheckStatus = GetReadyCheckStatus

_All = "all"
_IFReadyCheckUnitList = _IFReadyCheckUnitList or UnitList(_Name)

function _IFReadyCheckUnitList:OnUnitListChanged()
	self:RegisterEvent("READY_CHECK")
	self:RegisterEvent("READY_CHECK_CONFIRM")
	self:RegisterEvent("READY_CHECK_FINISHED")
	
	self.OnUnitListChanged = nil
end

function RefreshCheck(self, event, unit)
	local method
	local arg1
	
	if event == "READY_CHECK" or event == "READY_CHECK_CONFIRM" then
		method = "Confirm"
		
		arg1 = self.Unit and GetReadyCheckStatus(self.Unit)
		
		if arg1 == "ready" then
			arg1 = true
		elseif arg1 == "notready" then
			arg1 = false
		else
			method = "Start"
			arg1 = nil
		end
		
		self[method](self, arg1)
	else
		method = "Finish"
		arg1 = nil
		
		self:ThreadCall(method)
	end
end

function _IFReadyCheckUnitList:ParseEvent(event, unit)
	self:EachK(_All, RefreshCheck, event, unit)
end

interface "IFReadyCheck"
	extend "IFUnitElement"
	
	_IFReadyCheckUnitList = _IFReadyCheckUnitList
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Dispose(self)
		_IFReadyCheckUnitList[self] = nil
	end
	
	------------------------------------
	--- Start the ready check
	-- @name Start
	-- @type function
	------------------------------------
	function Start(self)
	end
	
	------------------------------------
	--- Confirm the ready check
	-- @name Confirm
	-- @type function
	-- @param ready boolean
	------------------------------------
	function Confirm(self, ready)		
	end
	
	------------------------------------
	--- Finish the ready check
	-- @name Finish
	-- @type function
	------------------------------------
	function Finish(self)
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------	
	
	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	
	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function IFReadyCheck(self)
		_IFReadyCheckUnitList[self] = _All
	end
endinterface "IFReadyCheck"