-- Author      : Kurapica
-- Create Date : 2012/07/14
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- IFRune
-- @type Interface
-- @name IFRune
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.IFRune", version) then
	return
end

pcall = pcall
errorhandler = errorhandler

_All = "all"
_IFRuneUnitList = _IFRuneUnitList or UnitList(_Name)

function _IFRuneUnitList:OnUnitListChanged()
	self:RegisterEvent("RUNE_POWER_UPDATE")
	self:RegisterEvent("RUNE_TYPE_UPDATE")
	
	self.OnUnitListChanged = nil
end

function _IFRuneUnitList:ParseEvent(event, runeIndex, isEnergize)
	local chk, ret
	
	if event == "RUNE_TYPE_UPDATE" then
		self:EachK(_All, "Refresh", runeIndex)
	elseif event == "RUNE_POWER_UPDATE" then
		self:EachK(_All, "UpdatePower", runeIndex, isEnergize)
	end
end

interface "IFRune"
	extend "IFUnitElement"
	
	_IFRuneUnitList = _IFRuneUnitList
	local UnitClass = UnitClass
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Dispose(self)
		_IFRuneUnitList[self] = nil
	end

	------------------------------------
	--- Called when RUNE_POWER_UPDATE event triggered
	-- @name UpdatePower
	-- @class function
	------------------------------------
	function UpdatePower(self)
		Log(1, "[%s][UpdatePower]", tostring(self:GetClass()))
	end
	
	------------------------------------------------------
	-- Property
	------------------------------------------------------	
	
	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	local function OnUnitChanged(self)
		if self.Unit and self.Unit:lower() == "player" then
			_IFRuneUnitList[self] = _All
		else
			_IFRuneUnitList[self] = nil
		end
	end
	
	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function IFRune(self)
		if select(2, UnitClass("player")) == "DEATHKNIGHT" then
			self.OnUnitChanged = self.OnUnitChanged + OnUnitChanged
		end
	end
endinterface "IFRune"