-- Author      : Kurapica
-- Create Date : 2012/07/22
-- Change Log  :

----------------------------------------------------------------------------------------------------------------------------------------
--- IFShard
-- @type Interface
-- @name IFShard
----------------------------------------------------------------------------------------------------------------------------------------

-- Check Version
local version = 1
if not IGAS:NewAddon("IGAS.Widget.Unit.IFShard", version) then
	return
end

pcall = pcall
errorhandler = errorhandler

_All = "all"
_IFShardUnitList = _IFShardUnitList or UnitList(_Name)

function _IFShardUnitList:OnUnitListChanged()
	self:RegisterEvent("UNIT_POWER_FREQUENT")
	
	self.OnUnitListChanged = nil
end

function _IFShardUnitList:ParseEvent(event, unit, powerType)
	if unit ~= "player" or powerType ~= "SOUL_SHARDS" then return end
	
	self:EachK(_All, "Refresh")
end

interface "IFShard"
	extend "IFUnitElement"
	
	local UnitClass = UnitClass
	_IFShardUnitList = _IFShardUnitList
	
	------------------------------------------------------
	-- Script
	------------------------------------------------------

	------------------------------------------------------
	-- Method
	------------------------------------------------------
	function Dispose(self)
		_IFShardUnitList[self] = nil
	end

	------------------------------------------------------
	-- Property
	------------------------------------------------------	
	
	------------------------------------------------------
	-- Script Handler
	------------------------------------------------------
	local function OnUnitChanged(self)
		if self.Unit and self.Unit:lower() == "player" then
			_IFShardUnitList[self] = _All
			self.Visible = true
		else
			_IFShardUnitList[self] = nil
			self.Visible = false
		end
	end
	
	------------------------------------------------------
	-- Constructor
	------------------------------------------------------
	function IFShard(self)
		if select(2, UnitClass("player")) == "WARLOCK" then
			self.OnUnitChanged = self.OnUnitChanged + OnUnitChanged
		else
			self.Visible = false
		end
	end
endinterface "IFShard"